<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="id"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'image'">
              <a-image :src="record.image" :width="50" />
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">显示</a-tag>
              <a-tag v-if="record.status === 1" color="red">隐藏</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a-popconfirm
                  title="确定要移除该门店用户吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">移除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <MerchantAccountEdit
        v-model:visible="showEdit"
        :data="current"
        :merchantId="merchantId"
        @done="reload"
      />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref, watch } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import { toDateString } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import MerchantAccountEdit from './components/merchantAccountEdit.vue';
  import {
    pageMerchantAccount,
    removeMerchantAccount,
    removeBatchMerchantAccount
  } from '@/api/shop/merchantAccount';
  import type {
    MerchantAccount,
    MerchantAccountParam
  } from '@/api/shop/merchantAccount/model';
  import router from '@/router';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<MerchantAccount[]>([]);
  // 当前编辑数据
  const current = ref<MerchantAccount | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);
  // 门店ID
  const merchantId = ref(0);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    if (merchantId.value > 0) {
      where.merchantId = merchantId.value;
    }
    console.log('>>>>>>>>', merchantId.value);
    return pageMerchantAccount({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: '用户ID',
      dataIndex: 'userId',
      key: 'userId',
      align: 'center',
      width: 90
    },
    {
      title: '店铺名称',
      dataIndex: 'merchantName',
      key: 'merchantName',
      align: 'center'
    },
    {
      title: '账号',
      dataIndex: 'phone',
      key: 'phone',
      align: 'center'
    },
    {
      title: '真实姓名',
      dataIndex: 'realName',
      key: 'realName',
      align: 'center'
    },
    {
      title: '角色',
      dataIndex: 'roleName',
      key: 'roleName',
      align: 'center'
    },
    {
      title: '备注',
      dataIndex: 'comments',
      key: 'comments',
      align: 'center'
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: MerchantAccountParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: MerchantAccount) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: MerchantAccount) => {
    const hide = message.loading('请求中..', 0);
    removeMerchantAccount(row.id)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchMerchantAccount(selection.value.map((d) => d.id))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    console.log('query()', merchantId.value);
    loading.value = true;
    reload();
  };

  /* 自定义行属性 */
  const customRow = (record: MerchantAccount) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };

  watch(
    () => router.currentRoute.value.params.id,
    (id) => {
      if (id) {
        if (id == ':id') {
          merchantId.value = 0;
        } else {
          merchantId.value = Number(id);
        }
      }
      query();
    },
    { immediate: true }
  );
</script>

<script lang="ts">
  export default {
    name: 'MerchantAccount'
  };
</script>

<style lang="less" scoped></style>
